; GUI #
include win64a.inc
;stroke.c - This program demonstrates some characters of a stroke (vector) 
;font. The characters are represented by display lists, which are given 
;numbers which correspond to the ASCII values of the characters.  Use of 
;glCallLists() is demonstrated.
; --------------- 
WINDOWWIDTH	= 470
WINDOWHEIGHT	= 160
PT     = 1
STROKE = 2
PEND   = 3
CHARPOINT struct 
       x     dd ?
       y     dd ?
       type_ dd ?
CHARPOINT ends
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax			;hIconSm
	push	rdi			;lpszClassName
	push	rbx			;lpszMenuName
	push	COLOR_WINDOWTEXT+1	;hbrBackground
	push	rax			;hCursor
	push	rax        		;hIcon
	push	rsi			;hInstance
	push	rbx        		;cbClsExtra & cbWndExtra
	pushaddr WndProc		;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC)shl 32 \
	or (sizeof WNDCLASSEX)
	push	rax                     ;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0
	cmp	msg.wParam,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local base:DWORD

        mov	hWin,rcx
	xor	ebx,ebx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
        cmp	edx,WM_DESTROY
	je      wmDESTROY     
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY::invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hrc
	invoke	ReleaseDC,hWin,hDC
	invoke	RtlExitUserProcess,NULL
wmCREATE:invoke	GetDC    ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax;eax=hDC
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hrc,rax
;   
	invoke	wglMakeCurrent,hDC,eax
;---------------------------------------------------
        invoke  glShadeModel,GL_FLAT
	invoke  glGenLists,128
	mov     base,eax
	invoke  glListBase,eax

	mov     eax, base
	add     eax, dword ptr 'A'
	invoke  glNewList, eax, GL_COMPILE
	mov	ecx,offset Adata
	invoke	drawLetter
	invoke  glEndList

	mov     eax, base
	add     eax, dword ptr 'E'
	invoke  glNewList, eax, GL_COMPILE
     	mov	ecx,offset Edata
	invoke	drawLetter
	invoke  glEndList

	mov     eax, base
	add     eax, dword ptr 'P'
	invoke  glNewList, eax, GL_COMPILE
     	mov	ecx,offset Pdata
	invoke	drawLetter
	invoke  glEndList

	mov     eax, base
	add     eax, dword ptr 'R'
	invoke  glNewList, eax, GL_COMPILE
     	mov	ecx,offset Rdata
	invoke	drawLetter
	invoke  glEndList

	mov     eax, base
	add     eax, dword ptr 'S'
	invoke  glNewList, eax, GL_COMPILE
     	mov	ecx,offset Sdata
	invoke	drawLetter
	invoke  glEndList

	mov     eax, base
	add     eax, dword ptr ' '
	invoke  glNewList, eax, GL_COMPILE
	movd	xmm2,ebx
	movd	xmm1,ebx
	movd	xmm0,const8_0
	invoke  glTranslatef
	invoke  glEndList
;----------------------------------
	invoke	GLReshape,WINDOWWIDTH,WINDOWHEIGHT	
        jmp	wmBYE
wmSIZE:;;     
	movzx	ecx,r9w
	mov	edx,r9d
	shr	edx,16
        invoke	GLReshape
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
;  
        invoke  glClear, GL_COLOR_BUFFER_BIT
	mov	eax,const1_0
	movd	xmm2,eax
	movd	xmm1,eax
	movd	xmm0,eax
	invoke  glColor3f
	invoke  glPushMatrix
	mov	eax,const2_0
	movd	xmm2,eax
	movd	xmm1,eax
	movd	xmm0,eax
	invoke  glScalef
	movd	xmm2,ebx
	movd	xmm1,const30_0
	movd	xmm0,const10_0
	invoke  glTranslatef
	mov	ecx,offset test1
	invoke	printStrokedString
	invoke  glPopMatrix
	invoke  glPushMatrix
	mov	eax,const2_0
	movd	xmm2,eax
	movd	xmm1,eax
	movd	xmm0,eax
	invoke  glScalef
	movd	xmm2,ebx
	movd	xmm1,const13_0
	movd	xmm0,const10_0
	invoke  glTranslatef
	mov	ecx,offset test2
	invoke	printStrokedString
	invoke  glPopMatrix
	invoke  glFlush
;----------------------------------------
;   
        invoke	SwapBuffers,hDC
wmBYE:	leave
	xor	eax,eax
	retn	
WndProc	endp

drawLetter proc letter:dword ;CHARPOINT x, y, type

	mov	letter,ecx

	invoke  glBegin, GL_LINE_STRIP
@0:	mov	ecx,letter
	mov	eax,[rcx + CHARPOINT.type_]
	cmp	eax,PT
	jnz	@f
	lea     ecx,[rcx + CHARPOINT.x]
	invoke  glVertex2fv
	jmp	@2
@@:	cmp	eax,STROKE
	jnz	@f
	lea     ecx,[rcx + CHARPOINT.x]
	invoke  glVertex2fv
	invoke  glEnd
	invoke  glBegin, GL_LINE_STRIP
	jmp	@2
@@:	cmp	eax,PEND
	jz	@f
@2:	add     letter,sizeof CHARPOINT
	jmp	@0
@@:	lea     ecx,[rcx + CHARPOINT.x]
	invoke  glVertex2fv
	invoke  glEnd
	movd	xmm2,ebx
	movd	xmm1,ebx
	movd	xmm0,const8_0
	invoke  glTranslatef
	leave
	retn
drawLetter endp

printStrokedString proc  string:dword

	mov	string,ecx

	invoke	strlen
	invoke  glCallLists,eax,GL_BYTE,string
	leave
	retn
printStrokedString endp

GLReshape proc w:dword,h:dword
local resultqa:QWORD
local resultqb:QWORD

	mov	w,ecx
	mov	h,edx
	invoke  glViewport,0,0,w,h
	invoke  glMatrixMode,GL_PROJECTION
	invoke  glLoadIdentity
	fild    w
	fstp    resultqa
	fild    h
	fstp    resultqb
	movq	xmm3,resultqb
	movq	xmm2,rbx
	movq	xmm1,resultqa
	movq	xmm0,rbx
	invoke  gluOrtho2D
	leave
	retn
GLReshape endp
;----------------------------------------
hDC	dq	?
hrc	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR;  
  	nVersion          dw	1;  
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or \
	PFD_DRAW_TO_WINDOW ;  ,     
  	iPixelType        db	PFD_TYPE_RGBA; RGBA 
  	cColorBits        db	32;   
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;  
  	cAlphaBits        db	0;  
  	cAlphaShift       db	0;  
  	cAccumBits        db	0;  
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;  
  	cDepthBits        db	32;32  Z- ( )
  	cStencilBits      db	0;  
  	cAuxBuffers       db	0;  
  	iLayerType        db	PFD_MAIN_PLANE;  
  	bReserved         db	0;
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;  

;double----------------------------
constd1_0	dq 1.0
constd0_1	dq 0.1
constd2_0	dq 2.0
constd90_0	dq 90.0
constd100_0	dq 100.0
ratio		dq 1.1
;float-------------------------------
const1_0	dd 1.0
const2_0	dd 2.0
const_3_0	dd -3.0
const_3_5	dd -3.5
const8_0	dd 8.0
const10_0	dd 10.0
const13_0	dd 13.0
const30_0	dd 30.0
const128_0	dd 128.0
;---------------------------------
szClassName	db "Uncle Remus tales:#40 OpenGL - Stroke Vector Font",0
test1     	db "A SPARE SERAPE APPEARS AS",0
test2     	db "APES PREPARE RARE PEPPERS",0
FileName	db "br_Rabbit3.cur",0
  Adata CHARPOINT <0.0,  0.0, PT>
	CHARPOINT <0.0,  9.0, PT>
	CHARPOINT <1.0, 10.0, PT>
	CHARPOINT <4.0, 10.0, PT>
	CHARPOINT <5.0,  9.0, PT>
	CHARPOINT <5.0,  0.0, STROKE>
	CHARPOINT <0.0,  5.0, PT>
	CHARPOINT <5.0,  5.0, PEND>

  Edata CHARPOINT <5.0,  0.0, PT>
	CHARPOINT <0.0,  0.0, PT>
	CHARPOINT <0.0, 10.0, PT>
	CHARPOINT <5.0, 10.0, STROKE>
	CHARPOINT <0.0,  5.0, PT>
	CHARPOINT <4.0,  5.0, PEND>

  Pdata CHARPOINT <0.0,  0.0, PT>
	CHARPOINT <0.0, 10.0, PT>
	CHARPOINT <4.0, 10.0, PT>
	CHARPOINT <5.0,  9.0, PT>
	CHARPOINT <5.0,  6.0, PT>
	CHARPOINT <4.0,  5.0, PT>
	CHARPOINT <0.0,  5.0, PEND>

  Rdata CHARPOINT <0.0,  0.0, PT>
	CHARPOINT <0.0, 10.0, PT>
	CHARPOINT <4.0, 10.0, PT>
	CHARPOINT <5.0,  9.0, PT>
	CHARPOINT <5.0,  6.0, PT>
	CHARPOINT <4.0,  5.0, PT>
	CHARPOINT <0.0,  5.0, STROKE>
	CHARPOINT <3.0,  5.0, PT>
	CHARPOINT <5.0,  0.0, PEND>

  Sdata CHARPOINT <0.0,  1.0, PT>
	CHARPOINT <1.0,  0.0, PT>
	CHARPOINT <4.0,  0.0, PT>
	CHARPOINT <5.0,  1.0, PT>
	CHARPOINT <5.0,  4.0, PT>
	CHARPOINT <4.0,  5.0, PT>
	CHARPOINT <1.0,  5.0, PT>
	CHARPOINT <0.0,  6.0, PT>
	CHARPOINT <0.0,  9.0, PT>
	CHARPOINT <1.0, 10.0, PT>
	CHARPOINT <4.0, 10.0, PT>
	CHARPOINT <5.0,  9.0, PEND>
end